program define cumulnorm
	syntax varname [if] [in], [ refopts(string) * ]
	
	marksample touse
	
	// create observed CDF
	tempvar cumul
	cumul `varlist' if `touse', gen(`cumul')
	label var `cumul' "observed"
	
	// collect info for reference CDF
	qui sum `varlist' if `touse'
	local m   = r(mean)
	local sd  = r(sd)
	local min = r(min)
	local max = r(max)
	
	// xtitle
	local varl : variable label `varlist'
	if "`varl'" == "" {
		local xtitle `"xtitle("`varlist'")"'
	}
	else {
		local xtitle `"xtitle(`"`varl'"')"'
	}
	
	// graph
	twoway scatter `cumul' `varlist', `options' ||    ///
       function reference = normal((x-`m')/`sd'),     ///
	   range(`min' `max') lpattern(solid) lcolor(red) ///
	   ytitle("Pr(Y {&le} y)") `xtitle' `refopts'
end
	   
